#!/usr/bin/perl

use File::Path;
use POSIX ":sys_wait_h";

$timeout = 60;

%{ENV}->{"MOZILLA_FIVE_HOME"}="/opt/gnome/lib/mozilla-1.4.2";
%{ENV}->{"LD_LIBRARY_PATH"}="/opt/gnome/lib/mozilla-1.4.2:/opt/gnome/lib:" . $ENV{"LD_LIBRARY_PATH"};

umask 022;

if ( -f "/opt/gnome/lib/mozilla-1.4.2/regxpcom" )
{
    # remove all of the old files
    rmtree("/opt/gnome/lib/mozilla-1.4.2/chrome/overlayinfo");
    unlink </opt/gnome/lib/mozilla-1.4.2/chrome/*.rdf>;
    unlink("/opt/gnome/lib/mozilla-1.4.2/component.reg");
    unlink("/opt/gnome/lib/mozilla-1.4.2/components/compreg.dat");

    # crate a new clean path
    mkpath("/opt/gnome/lib/mozilla-1.4.2/chrome/overlayinfo");

    # run regxpcom
    $pid = fork();

    # I am the child.
    if ($pid == 0) {
	exec("/opt/gnome/lib/mozilla-1.4.2/regxpcom > /dev/null 2> /dev/null");
    }
    # I am the parent.
    else {
	my $timepassed = 0;
	do {
	    $kid = waitpid($pid, &WNOHANG);
	    sleep(1);
	    $timepassed++;
        } until $kid == -1 || $timepassed > $timeout;

	# should we kill?
	if ($timepassed > $timeout) {
	    kill (9, $pid);
	}
    }

    # and run regchrome for good measure
    $pid = fork();

    # I am the child.
    if ($pid == 0) {
	exec("/opt/gnome/lib/mozilla-1.4.2/regchrome > /dev/null 2> /dev/null");
    }
    # I am the parent.
    else {
	my $timepassed = 0;
	do {
	    $kid = waitpid($pid, &WNOHANG);
	    sleep(1);
	    $timepassed++;
        } until $kid == -1 || $timepassed > $timeout;

	# should we kill?
	if ($timepassed > $timeout) {
	    kill (9, $pid);
	}
    }

}

